package szakdolgozat;

import java.util.ArrayList;
import java.util.List;

public class ExpressionSolverProgram {
	String solvable;
	double x;
	double y;
	String result;
	static List<String> otosPrecedenciak;
	static List<String> negyesPrecedenciak;
	static List<String> harmasPrecedenciak;
	static List<String> kettesPrecedenciak;

	public ExpressionSolverProgram(String tosolve,double x, double y){
		solvable=tosolve;
		this.x=x;
		this.y=y;
		result="";
	}

	public String getSolvable(){
		return solvable;
	}

	public Double getX(){
		return x;
	}

	public Double getY(){
		return y;
	}

	public void start(){
		otosPrecedenciak = new ArrayList<String>();
		negyesPrecedenciak = new ArrayList<String>();
		harmasPrecedenciak = new ArrayList<String>();
		kettesPrecedenciak = new ArrayList<String>();
		FeltoltTomb(otosPrecedenciak);
		FeltoltTomb2(negyesPrecedenciak);
		FeltoltTomb3(harmasPrecedenciak);
		FeltoltTomb4(kettesPrecedenciak);

		solvable=switchXYToNumbers(solvable,x,y);
		solvable=atalakit2(solvable);

		String vegeredmeny=braceResolution(solvable,x,y);

		result=vegeredmeny;



	}

	public String atalakit2(String s){
		String ss=s;
		ss=ss.replaceAll("\\(-", "zz");
		ss=ss.replaceAll("-", "+-");
		ss=ss.replaceAll("zz", "(-");
		ss=ss.replaceAll("--", "");

		return ss;
	}

	public String switchXYToNumbers(String s, double x, double y){
		String ss=s;
		String ystring;

		if(y<0){
			ystring="("+Double.toString(y)+")";
		}
		else{
			ystring=Double.toString(y);
		}
		String xstring;
		if(x<0){
			xstring="("+Double.toString(x)+")";
		}
		else{
			xstring=Double.toString(x);
		}
		ss=ss.replaceAll("y", ystring);
		ss=ss.replaceAll("exp", "epp");
		ss=ss.replaceAll("x", xstring);
		ss=ss.replaceAll("epp", "exp");

		return ss;
	}

	public static void FeltoltTomb(List<String> otosprecedenciak){
		otosprecedenciak.add("abs");
		otosprecedenciak.add("acos");
		otosprecedenciak.add("asin");
		otosprecedenciak.add("atan");
		otosprecedenciak.add("cos");
		otosprecedenciak.add("exp");
		otosprecedenciak.add("log");
		otosprecedenciak.add("sin");
		otosprecedenciak.add("tan");
	}

	public static void FeltoltTomb2(List<String> negyesprecedenciak){
		negyesprecedenciak.add("sqrt");
		negyesprecedenciak.add("cbrt");
		negyesprecedenciak.add("^");
	}

	public static void FeltoltTomb3(List<String> harmasprecedenciak){
		harmasprecedenciak.add("*");
		harmasprecedenciak.add("/");
	}

	public static void FeltoltTomb4(List<String> kettesprecedenciak){
		kettesprecedenciak.add("+");
		//kettesprecedenciak.add("-");
	}

	public static boolean isSzam(char c){
		if((c>='0' && c<='9') || c=='.' || c=='-'){
			return true;
		}
		else{
			return false;
		}
	}


	public static String braceResolution(String s, double x, double y){

		System.out.println(s);

		int kezdoidx=-1;
		int vegsoidx=-1;
		boolean leall=false;
		while(!leall){
			kezdoidx=-1;
			for(int i=0;i<s.length();i++){
				if(s.charAt(i)=='('){
					kezdoidx=i;
				}
			}
			if(kezdoidx!=-1){
				int j=kezdoidx+1;
				vegsoidx=j;
				while(j<s.length() && s.charAt(j)!=')'){
					vegsoidx=j;
					j++;
				}


				String s1=s.substring(0,kezdoidx);
				//System.out.println(s1);
				String s3="";
				if(vegsoidx<s.length()-1){
					s3=s.substring(vegsoidx+2);
				}

				String s2=expressionSolver(s.substring(kezdoidx+1,vegsoidx+1));
				s2=s2.replace("--", "");

				s=s1+s2+s3;
				s=s.replaceAll("--", "");

			}
			else{
				leall=true;
			}
		}
		s=expressionSolver(s);

		return s;

	}

	public static String expressionSolver(String s){
		s=s.replaceAll("--", "");
		boolean leallas=false;

		for(int i=0;i<otosPrecedenciak.size();i++){

			leallas=false;
			while(!leallas){
				s=s.replaceAll("--", "");
				leallas=true;
				int kezdoindex;
				if((kezdoindex=s.indexOf(otosPrecedenciak.get(i)))!=-1){
					leallas=false;
					int j=kezdoindex+otosPrecedenciak.get(i).length();
					int vegsoindex=j;
					while(j<s.length() && isSzam(s.charAt(j))){
						vegsoindex=j;
						j++;
					}

					String s1=s.substring(0,kezdoindex);
					String s3="";
					double Szam;
					if(vegsoindex+1<s.length()){
						s3=s.substring(vegsoindex+1);
						Szam=Double.parseDouble(s.substring(kezdoindex+otosPrecedenciak.get(i).length(), vegsoindex+1));
					}else{
						Szam=Double.parseDouble(s.substring(kezdoindex+otosPrecedenciak.get(i).length()));
					};
					double Eredmeny=0;
					if(otosPrecedenciak.get(i).equals("abs")){
						Eredmeny=Math.abs(Szam);
					}
					else if(otosPrecedenciak.get(i).equals("asin")){
						Eredmeny=Math.asin(Szam);
					}
					else if(otosPrecedenciak.get(i).equals("acos")){
						Eredmeny=Math.acos(Szam);
					}
					else if(otosPrecedenciak.get(i).equals("cos")){
						Eredmeny=Math.cos(Szam);
					}
					else if(otosPrecedenciak.get(i).equals("exp")){
						Eredmeny=Math.exp(Szam);
					}
					else if(otosPrecedenciak.get(i).equals("log")){
						Eredmeny=Math.log(Szam);
					}
					else if(otosPrecedenciak.get(i).equals("sin")){
						Eredmeny=Math.sin(Szam);
					}

					else if(otosPrecedenciak.get(i).equals("tan")){
						Eredmeny=Math.tan(Szam);
					}

					String s2=Double.toString(Eredmeny);
					s=s1+s2+s3;

					s=s.replaceAll("--", "");
				}
			}
		}
		leallas=false;

		for(int i=0;i<negyesPrecedenciak.size();i++){
			System.out.println("Belép a ^ miatt");
			leallas=false;
			while(!leallas){
				s=s.replaceAll("--", "");
				leallas=true;
				int kezdoindex;
				if((kezdoindex=s.indexOf(negyesPrecedenciak.get(i)))!=-1){
					leallas=false;
					int j;
					String s1="";
					double Szam1=0;
					if(kezdoindex>0){
						j=kezdoindex-1;
						int vegsoindex=j;
						while(j>=0 && isSzam(s.charAt(j))){
							vegsoindex=j;
							j--;
						}
						if(isSzam(s.charAt(vegsoindex))){
							Szam1=Double.parseDouble(s.substring(vegsoindex,kezdoindex));
							s1=s.substring(0,vegsoindex);
						}
						else{
							s1=s.substring(0, kezdoindex);
						}
					}
					j=kezdoindex+negyesPrecedenciak.get(i).length();
					int vegsoindex=j;
					while(j<s.length() && isSzam(s.charAt(j))){
						vegsoindex=j;
						j++;
					}
					String s3="";
					double Szam2;
					if(vegsoindex+1<s.length()){
						s3=s.substring(vegsoindex+1);
						Szam2=Double.parseDouble(s.substring(kezdoindex+negyesPrecedenciak.get(i).length(), vegsoindex+1));
					}else{
						Szam2=Double.parseDouble(s.substring(kezdoindex+negyesPrecedenciak.get(i).length()));
					};
					double Eredmeny=0;
					if(negyesPrecedenciak.get(i).equals("^")){
						Eredmeny=Math.pow(Szam1, Szam2);
					}
					else if(negyesPrecedenciak.get(i).equals("sqrt")){
						Eredmeny=Math.sqrt(Szam2);
					}
					else if(negyesPrecedenciak.get(i).equals("cbrt")){
						Eredmeny=Math.cbrt(Szam2);
					}
					String s2=Double.toString(Eredmeny);

					s=s1+s2+s3;
					s=s.replaceAll("--", "");
				}
			}
		}
		leallas=false;

		for(int i=0;i<harmasPrecedenciak.size();i++){
			leallas=false;
			while(!leallas){
				s=s.replaceAll("--", "");
				leallas=true;
				int kezdoindex;
				if((kezdoindex=s.indexOf(harmasPrecedenciak.get(i)))!=-1){
					leallas=false;
					int j;
					j=kezdoindex-1;
					int vegsoindex=j;
					while(j>=0 && isSzam(s.charAt(j))  ){
						vegsoindex=j;
						j--;
					}
					double Szam1=0;
					String s1="";
					Szam1=Double.parseDouble(s.substring(vegsoindex,kezdoindex));
					s1=s.substring(0,vegsoindex);
					j=kezdoindex+harmasPrecedenciak.get(i).length();
					vegsoindex=j;
					while(j<s.length() && isSzam(s.charAt(j))){
						vegsoindex=j;
						j++;
					}
					String s3="";
					double Szam2;
					if(vegsoindex+1<s.length()){
						s3=s.substring(vegsoindex+1);
						Szam2=Double.parseDouble(s.substring(kezdoindex+harmasPrecedenciak.get(i).length(), vegsoindex+1));
					}else{
						Szam2=Double.parseDouble(s.substring(kezdoindex+harmasPrecedenciak.get(i).length()));
					};

					double Eredmeny=0;
					if(harmasPrecedenciak.get(i).equals("/")){
						Eredmeny=Szam1/Szam2;
					}
					else if(harmasPrecedenciak.get(i).equals("*")){

						Eredmeny=Szam1*Szam2;

					}
					String s2=Double.toString(Eredmeny);
					s=s1+s2+s3;
					s=s.replaceAll("--", "");
				}
			}
		}

		leallas=false;
		for(int i=0;i<kettesPrecedenciak.size();i++){
			leallas=false;
			while(!leallas){
				s=s.replaceAll("--", "");
				leallas=true;
				int kezdoindex;
				if((kezdoindex=s.indexOf(kettesPrecedenciak.get(i)))!=-1){
					leallas=false;
					int j=kezdoindex-1;
					int vegsoindex=j;
					while(j>=0 && isSzam(s.charAt(j))){
						vegsoindex=j;
						j--;
					}

					double Szam1=0;
					String s1="";

					Szam1=Double.parseDouble(s.substring(vegsoindex,kezdoindex));
					s1=s.substring(0,vegsoindex);//EZEDDIGNEMITTVOLT
					j=kezdoindex+kettesPrecedenciak.get(i).length();

					vegsoindex=j;
					while(j<s.length() && isSzam(s.charAt(j))){
						vegsoindex=j;
						j++;
					}

					String s3="";
					double Szam2;

					if(vegsoindex+1<s.length()){
						s3=s.substring(vegsoindex+1);
						Szam2=Double.parseDouble(s.substring(kezdoindex+kettesPrecedenciak.get(i).length(), vegsoindex+1));
					}else{

						Szam2=Double.parseDouble(s.substring(kezdoindex+kettesPrecedenciak.get(i).length()));
					}
					double Eredmeny=0;
					if(kettesPrecedenciak.get(i).equals("+")){
						Eredmeny=Szam1+Szam2;
					}
					else if(kettesPrecedenciak.get(i).equals("-")){

						Eredmeny=Szam1-Szam2;

					}
					String s2=Double.toString(Eredmeny);

					s=s1+s2+s3;
					s=s.replaceAll("--", "");

				}
			}
		}

		return s;
	}
}
